/***********************************************
*  FreeRTOS Test Program sample4
*  Semaphore Control
***********************************************/
#include <p32xxxx.h>
#include "FreeRTOS.h" 					/* FreeRTOSwb_ */
#include "queue.h"
#include "semphr.h"
#include <Lcd_Lib32.h>
/***  RtBM[Vݒ  ***/
//CPU=80MHz Peri=80MHz, HS+PLL, Divider=1/2, PLL=20x, WDT=Off
#pragma config FNOSC = PRIPLL, POSCMOD = HS, FPLLIDIV = DIV_2
#pragma config FPLLMUL = MUL_20, FPBDIV = DIV_1, FPLLODIV = DIV_1
#pragma config FWDTEN = OFF, OSCIOFNC = ON, ICESEL = ICS_PGx2

/* ϐ`*/
xQueueHandle lcdQueue;
xSemaphoreHandle lcdSemaphore;

/* ֐vg */
void vTask1( void *pvParameters );		// ^XNP
void vTask2( void *pvParameters );		// ^XNQ
void vTask3( void *pvParameters );		// ^XNR
void itostring(char digit, unsigned int data, char *buffer);

/****************** C֐ ************************/
int main(void){
	/* VXeݒ */
	SYSTEMConfigPerformance(SYS_FREQ);		// VXeő
	mJTAGPortEnable(DEBUG_JTAGPORT_OFF);	// JTAG𖳌
	AD1PCFG = 0xFFFF;						// ׂăfW^I/O
	LATA = 0;							// I/Oݒ
	TRISA = 0;
	// LCD̏ݒƏ\
	TRISE = 0x0100;						// LCDp RE8 INT1
	TRISDbits.TRISD4 = 0;					// LCDp
	TRISDbits.TRISD5 = 0;					// LCDp
	LCD_WR = 0;							// WR͏Low
	TRISBbits.TRISB15 = 0;					// LCDp
	lcd_init();							// LCD
	lcd_clear();							// S
	lcd_str("Start!");					// JnbZ[W
	delay_ms(500);						// 0.5secԕ\
	// ^C}Qݒ 12.5nsec*256*62500=200msec
	OpenTimer2(T2_ON | T2_SOURCE_INT | T2_PS_1_256, 62500);
	ConfigIntTimer2(T2_INT_ON | T2_INT_PRIOR_2);
	/* 荞݋ */
	INTEnableSystemMultiVectoredInt();
	/* L[obt@@*/
	lcdQueue = xQueueCreate(5, 17);		// 17Byte x 5
	/* Z}tH */
	vSemaphoreCreateBinary(lcdSemaphore);
	if(lcdSemaphore != NULL){				// ɊmۂłH
		/* ^XN  */
		xTaskCreate( vTask1, "Task1", 100, NULL, 1, NULL );
		xTaskCreate( vTask2, "Task2", 100, NULL, 1, NULL );
		xTaskCreate( vTask3, "Task3", 100, NULL, 1, NULL );
		/* XPW[OJn@*/
		vTaskStartScheduler();
	}
	/********@C[v  *******/
	while(1)
	{	}
}

/**** ^C}Q荞ݏ *****/
void __ISR(8, ipl2) Timer2Handler(void)
{
	static portBASE_TYPE xHigherPriorityTaskWoken;

	mT2ClearIntFlag();						// 荞݃tONA
	xHigherPriorityTaskWoken = pdFALSE;
	xSemaphoreGiveFromISR(lcdSemaphore, &xHigherPriorityTaskWoken);
}

/***** ^XN1֐ ******/
void vTask1(void *pvParameters){
	static unsigned char Msg1[] = "Task1Count=xxxxx";
	static unsigned int Count1 = 0;

	while(1) {
		LATA ^= 0x80;							// LED_
		itostring(5, Count1, Msg1+11);			// bZ[Wp
		Count1++;
		/* L[ɓo^ */
		xQueueSendToBack(lcdQueue, Msg1, portMAX_DELAY);
		vTaskDelay(1000 / portTICK_RATE_MS);	// 1sec҂		
	}
}
/***** ^XN2֐ ******/
void vTask2(void *pvParameters){
	static unsigned char Msg2[] = "Task2Count=xxxxx";
	static unsigned int Count2 = 0;

	while(1)	{
		LATA ^= 0x40;							// LED_
		itostring(5, Count2, Msg2+11);			// bZ[Wp
		Count2++;
		/* Z}tH҂ */
		xSemaphoreTake(lcdSemaphore, portMAX_DELAY);
		/* L[ɓo^ */
		xQueueSendToBack(lcdQueue, Msg2, portMAX_DELAY);   
	}
}
/***** ^XN3֐ ******/
void vTask3(void *pvParameters){
	unsigned char Buf[32];

	while(1) {
		LATA ^= 0x20;						// LED_
		/* L[f[^o */
		xQueueReceive(lcdQueue, Buf, portMAX_DELAY);
		// bZ[WLCD\
		if(Buf[4] == '1')
			lcd_cmd(0x80);				// 1sڂ
		else
			lcd_cmd(0xC0);				// 2sڂ
		lcd_str(Buf);						// \s
	}
}

/*****************************************
*   l當ɕϊ
*****************************************/
void itostring(char digit, unsigned int data, char *buffer)
{
	char i;

	buffer += digit;						//̍Ō
	for(i=digit; i>0; i--) {				//ŉʌʂ
		buffer--;						//|C^[P
		*buffer = (data % 10) + '0';		//̌l𕶎ɂĊi[
		data = data / 10;					//-1
	}
}
